#include <TimeAlarms.h>
#include <Time.h>
#include <TimeLib.h>


// The set alarm time
time_t alarmTime = 0;
AlarmID_t alarmID;

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

void setup() {
  int i;
  
  // set the time, the week, month and year are not used in this program
  setTime(0,0,0,1,1,2017);
  // set the initial duration of the sunrise
  sunriseDuration = 20;
  // init the blinking, more on that in the gui
  blinkTimer = millis();
  blinkOn = true;

  // set the pin 13 to output, this is where the led of every arduino is
  pinMode(13, OUTPUT);
  // set the pins for the buttons as input with pullup
  for(i=0; i<BUTTON_CNT; i++) {
    pinMode(buttonPin[i], INPUT);
    digitalWrite(buttonPin[i], HIGH);
  }

  // init the timer, see pwm
  initTimer();

  // init the display, set text size and color
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.setTextSize(4);
  display.setTextColor(WHITE);
  display.display();
}


void loop() {
  checkInput();
  doSunrise();
  runState();

  // check if nextState changed
  stateChanged = false;
  if(state != nextState) {
    // if so set the new state and clear the display
    stateChanged = true;
    state = nextState;
    display.clearDisplay();
  }

  // toggle the blinkOn variable every BLINK_SPEED milliseconds
  if(blinkTimer + BLINK_SPEED < millis()) {
    blinkTimer = millis();
    blinkOn = !blinkOn;
  }

  // update the display
  display.display();

  // wait 10ms
  // When using the Alarm lib Alarm.delay(10) must be used
  Alarm.delay(10);
}

// This function is called when it is time for the alarm
void alarm() {
  sunrise = true;
  sunriseTime = millis();
}